#!/bin/sh

top="50"
outfile="allnames.txt"

# Extract names
if [ ! -f "$outfile" ]
then
	echo "Extract names..."
	#        
	# http://georgi.unixsol.org/programs/phones/data/
	zcat ../phones/data/*.gz  | sed -e 's|;| |g' | cut -d' ' -f1,2 | sort > $outfile
fi

function analyze() {
	TITLE="$1"
	CMD_EXTRACT="$2"
	CMD_STATS="$3"
	echo $TITLE
	if [ ! -f "$outfile" -a "$CMD_EXTRACT" != "" ]
	then
		echo $CMD_EXTRACT | sh > $outfile
	fi
	echo $CMD_STATS | sh
	echo
}

analyze "      " "" \
  "wc -l $outfile"

outfile="uniq_ownnames.txt"
analyze "   " \
  "cut -d' ' -f2- allnames.txt | sort | uniq" \
  "wc -l $outfile"

outfile="uniq_surnames.txt"
analyze "   " \
  "cut -d' ' -f1 allnames.txt | sort | uniq" \
  "wc -l $outfile"

outfile="top_fullnames.txt"
analyze " $top    " \
  "uniq -c allnames.txt | sort -rn" \
  "head -n $top $outfile | cat -n"

outfile="top_ownnames.txt"
analyze " $top   " \
  "cut -d' ' -f2 allnames.txt | sort | uniq -c | sort -rn" \
  "head -n $top $outfile | cat -n"

outfile="top_surnames.txt"
analyze " $top   " \
  "cut -d' ' -f1 allnames.txt | sort | uniq -c | sort -rn" \
  "head -n $top $outfile | cat -n"

outfile="top_male_ownnames.txt"
analyze " $top    " \
  "cut -d' ' -f2 allnames.txt | egrep -v '(||||||||)' | egrep -v '[]$' | sort | uniq -c | sort -rn" \
  "head -n $top $outfile | cat -n"

outfile="top_male_surnames.txt"
analyze " $top    " \
  "cut -d' ' -f1 allnames.txt | grep -v $ | sort | uniq -c | sort -rn" \
  "head -n $top $outfile | cat -n"

outfile="top_female_ownnames.txt"
analyze " $top    " \
  "cut -d' ' -f2 allnames.txt | egrep '[]$' | egrep -v '(|)' | sort | uniq -c | sort -rn" \
  "head -n $top $outfile | cat -n" \

outfile="top_female_surnames.txt"
analyze " $top    " \
  "cut -d' ' -f1 allnames.txt | egrep '[]$' | sort | uniq -c | sort -rn" \
  "head -n $top $outfile | cat -n" \
